// Message Declarations
message KeyMsg mapsto IntMsg {
sender mapsto src;    // field src in code represents sender
receiver mapsto dest; // field dest in code represents receiver
data mapsto info;     // field info holds data (the key)
}
message DataMsg mapsto IntMsg {
sender mapsto src;
receiver mapsto dest;
data mapsto info;
private data mapsto MAC; // fld MAC used for authentication
}

// Differentiating between Message Types
msgtypes mapsto IntMsg.type {
1: KeyMsg;  // when type = 1, this is a msg of type KeyMsg
2: DataMsg; // when type = 2, this is a msg of type DataMsg
}

// Number of iterations
iteration: 3; // verification stops after 3 timer firings

// Topology 
node 0 { 1; } // Linear topology between nodes 0 and 1
node 1 { 0; }

// Objective
// (If intruder sends corrupt data, sensor should NOT accept it) 
objective Authen {
  Intruder:SensorM.Send.send(DataMsg) -> !SensorM.Leds.greenOn();
}
