// Message Declarations
message Timestamp mapsto IntMsg  {
  sender mapsto src; // field src in code represents sender
  data mapsto info;  // field info holds data (the time stamp)
}
message DataMsg mapsto IntMsg {
  sender mapsto src;
  data mapsto info;
  data mapsto timestamp;
  private data mapsto MAC; // fld MAC used for authentication
}
message KeyMsg mapsto IntMsg {
  sender mapsto src;
  data mapsto info;
  data mapsto timestamp;
}
  
// Differentiating between Message Types
msgtypes mapsto IntMsg.type {
  1: Timestamp; // when type = 1, this is a msg of type Timestamp
  2: DataMsg;   // when type = 2, this is a msg of type DataMsg
  3: KeyMsg;    // when type = 2, this is a msg of type KeyMsg
}

// Number of iterations
iteration: 3;   // verification stops after 3 timer firings

// Topology
node 0 { 1; }   // Linear topology between nodes 0 and 1
node 1 { 0; }
  
// Objective
// (If intruder sends corrupt data, sensor should NOT accept it) 
objective Authen
{
  Intruder:SensorM.Send.send(DataMsg) -> !SensorM.Leds.greenOn();
}
