/*
 * (c) Copyright Improve S.A., 2002.
 * All Rights Reserved.
 */
package fr.improve.csharp.ui.internal;

import org.eclipse.jface.preference.*;
import org.eclipse.swt.SWT;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

/**
 * Preference page for the C Sharp editor, where it is possible to specify :
 * <br/>
 * - the path for the C Sharp compiler
 */
public class CSharpEditorPreferencePage
	extends FieldEditorPreferencePage
	implements IWorkbenchPreferencePage {

	public CSharpEditorPreferencePage() {
		super(GRID);
		// retrieves the preferences of the plugin
		IPreferenceStore store = CSharpUIPlugin.getDefault().getPreferenceStore();
		setPreferenceStore(store);
	}

	/**
	 * @see FieldEditorPreferencePage#createFieldEditors()
	 */
	protected void createFieldEditors() {
		
		DirectoryFieldEditor TinyRoot =
			new DirectoryFieldEditor(
				ICSharpPreferenceConstants.TINYROOT,
				NLS.getString("preferences.setTinyRoot"),
				getFieldEditorParent());
//		TinyRoot.setErrorMessage(
//			NLS.getString("preferences.compilerPathErrorMessage"));
//		TosRoot.setFileExtensions(new String[] { "nesc1.exe" });

		DirectoryFieldEditor TinyTos =
			new DirectoryFieldEditor(
				ICSharpPreferenceConstants.TINYTOS,
				NLS.getString("preferences.setTinyTos"),
				getFieldEditorParent());
//		TosRoot.setErrorMessage(
//			NLS.getString("preferences.compilerPathErrorMessage"));
//		TosRoot.setFileExtensions(new String[] { "nesc1.exe" });

		FileFieldEditor Spin =
			new FileFieldEditor(
				ICSharpPreferenceConstants.SPIN,
				NLS.getString("preferences.setSpinPath"),
				getFieldEditorParent());
		Spin.setErrorMessage(
		NLS.getString("preferences.spinPathErrorMessage"));
	    Spin.setFileExtensions(new String[] { "spin" });

	    FileFieldEditor Gcc =
			new FileFieldEditor(
				ICSharpPreferenceConstants.GCC,
				NLS.getString("preferences.setGccPath"),
				getFieldEditorParent());
	    Gcc.setErrorMessage(
		NLS.getString("preferences.gccPathErrorMessage"));
	    Spin.setFileExtensions(new String[] { "gcc" });
	    
/*		BooleanFieldEditor autoCompile =
			new BooleanFieldEditor(
				ICSharpPreferenceConstants.AUTO_COMPILE,
				NLS.getString("preferences.autoCompile"),
				SWT.NONE,
				getFieldEditorParent());
*/
		addField(TinyRoot);
		addField(TinyTos);
		addField(Spin);
		addField(Gcc);

	}

	/**
	* @see IWorkbenchPreferencePage#init
	*/
	public void init(IWorkbench workbench) {
	}

}