/*
 * (c) Copyright Improve S.A., 2002.
 * All Rights Reserved.
 */
package fr.improve.csharp.ui.internal.editor.utils;

import java.util.Vector;

import fr.improve.csharp.ui.internal.editor.csharp.ICSharpLanguageWords;
import org.eclipse.jface.text.rules.IWordDetector;

/**
 * A c sharp aware word detector.
 */
public class CSharpWordDetector
	implements IWordDetector, ICSharpLanguageWords {


	/* (non-Javadoc)
	 * Method declared on IWordDetector.
	 */
	public boolean isWordPart(char character) {
		for (int i = 0; i < keywords.length; i++) 
			if (((String) keywords[i]).indexOf(character) != -1)
				return true;	

		for (int i = 0; i < types.length; i++) 
			if (((String) types[i]).indexOf(character) != -1) 
				return true;

		for (int i = 0; i < constants.length; i++) 
			if (((String) constants[i]).indexOf(character) != -1) 
				return true;
		
		return false;
	}

	/* (non-Javadoc)
	 * Method declared on IWordDetector.
	 */
	public boolean isWordStart(char character) {
		for (int i = 0; i < keywords.length; i++) 
			if (((String) keywords[i]).charAt(0) == character)
				return true;	

		for (int i = 0; i < types.length; i++) 
			if (((String) types[i]).charAt(0) == character) 
				return true;

		for (int i = 0; i < constants.length; i++) 
			if (((String) constants[i]).charAt(0) == character) 
				return true;	
		
		return false;

	}

}